function x = newton(p,x0)
%NEWTON Calcola la correzione di Newton per P al punto X0
%
% X = NEWTON(P, X0) applica il metodo di Newton al polynomio P partendo dal
% punto X0. Il metodo esegue al più 15 passi e si ferma se il residuo è
% relativamente piccolo. Al termine ritorna l'approssimazione ottenuta. 
%

pp = derivata(p);
x = x0;
it = 1;
px = horner(p,x);

while it <= 15 && abs(px) > eps * 1e2 * abs(x)
  ppx = horner(pp,x);
  
  if ppx ~= 0  
    x = x - px / horner(pp,x);
  else
    x = x - px;
  end
  
  px = horner(p,x);
  it = it + 1;
end

end
